# -----------------------------------------
#
#  Darryl Brown
#  April 1994
#
#  parser(s) for breakpoint types
#  
#
# -----------------------------------------


set Collections "";
set Classes "";
set Structs "";

#  --------------------------------------------------------------


proc readInFieldsFromFile {fd} {

  set fieldFormat { #type# %[^#] #field# %[^ \n]}
  set fieldlist "";

  while {![eof $fd]} {
    gets $fd line;
    if {[scan $line $fieldFormat typestr fieldstr]} {
      lappend fieldlist [list $fieldstr $typestr];
    } else {
      break;
    }
  }


  return $fieldlist;
}
    
#  --------------------------------------------------------------


proc parseTypesFromFile {fd} {
  global Collections;
  global Classes;
  global Structs;
  
  set collectFormat1 { Collection %[^>] < %[^>] > ( %[^)] )};
  set collectFormat2 { Collection %[^<] < > ( %[^)] )};
  set classFormat { class %[^(] ( %[^)] )};
  set structFormat { struct %[^( \n] };
  gets $fd line;
  while {![eof $fd]} {
    if {([set num [scan $line $collectFormat1 coll elemtype parents]] > 1) ||
	  ([set num [scan $line $collectFormat2 coll parents]] >= 1)} {
	    if {$num == 2} {
	      set fields [readInFieldsFromFile $fd];
	      lappend Collections [concat $coll [list $parents] \
				   [list $fields]];
	    }
	    if {$num == 3} {
	      set fields [readInFieldsFromFile $fd];
	      lappend Collections [concat $coll \
				   " < " $elemtype " > " \
				   [list $parents] \
				   [list $fields]];
	    }
	    set parents "";
	  } 
    
    if {([set num [scan $line $classFormat class parents]] > 0)} {
      if {$num > 0} {
	set fields [readInFieldsFromFile $fd];
	lappend Classes [concat $class [list $parents] \
			 [list $fields]];
      }
      set parents "";
    } 

    if {([set num [scan $line $structFormat struct]] == 1)} {
      if {$num == 1} {
	set fields [readInFieldsFromFile $fd];
	lappend Structs [concat $struct [list $fields]];
      }
    }
    
    gets $fd line;
  }
}

#  --------------------------------------------------------------

set strPointer 0;
set strLength 0;

proc readInFieldsFromStr {str} {
  global strPointer;
  global strLength;
  set fieldFormat [format " #type# %%\[^#\] #field# %%\[^ \n\]"];
  set fieldlist "";
  set rexp [format "^\[^\n\]*\n"];

  while {[regexp -indices $rexp $strPointer ind]} {
    
    # grab next line;
    set line [string range $strPointer [lindex $ind 0] [lindex $ind 1]];
    #move strPointer to after this line;
    set strPointer [string range $strPointer [expr [lindex $ind 1]+2] end] ;
    
    if {[scan $line $fieldFormat typestr fieldstr]} {
      lappend fieldlist [list $fieldstr $typestr];
    } else {
      break;
    }
  }

  return $fieldlist;
}
    
#  --------------------------------------------------------------

proc parseTypesFromStr {str} {
  global Collections;
  global Classes;
  global Structs;
  global strPointer;
  global strLength;
  
  # construct the regular expression for all chars except a newline;
  set rexp [format "^\[^\n\]*\n"];
  #set up formats for scan-ning
  set collectFormat1 { Collection %[^>] < %[^>] > ( %[^)] )};
  set collectFormat2 { Collection %[^<] < > ( %[^)] )};
  set classFormat { class %[^(] ( %[^)] )};
  set structFormat { struct %[^( \n] };
  #set up global vals for string pointer/length
  set strPointer $str;
  set strLength [string length $str];

  while {[regexp -indices $rexp $strPointer ind]} {

    set line [string range $strPointer [lindex $ind 0] [lindex $ind 1]];
    set strPointer [string range $strPointer [expr [lindex $ind 1]+2] end] ;

    if {([set num [scan $line $collectFormat1 coll elemtype parents]] > 1) ||
	  ([set num [scan $line $collectFormat2 coll parents]] >= 1)} {
	    if {$num == 2} {
	      set fields [readInFieldsFromStr $str];
	      lappend Collections [concat $coll [list $parents] \
				   [list $fields]];
	    }
	    if {$num == 3} {
	      set fields [readInFieldsFromStr $str];
	      lappend Collections [concat $coll \
				   " < " $elemtype " > " \
				   [list $parents] \
				   [list $fields]];
	    }
	    set parents "";
	  } 
    
    if {([set num [scan $line $classFormat class parents]] > 0)} {
      if {$num > 0} {
	set fields [readInFieldsFromStr $str];
	lappend Classes [concat $class [list $parents] \
			 [list $fields]];
      }
      set parents "";
    } 

    if {([set num [scan $line $structFormat struct]] == 1)} {
      if {$num == 1} {
	set fields [readInFieldsFromStr $str];
	lappend Structs [concat $struct [list $fields]];
      }
    }
  }
}
