/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/


#define _AWE_

#include "Thread.h"
#include "GlobalStruct.h"

#define MaxCollection 100
#define NumberOfElement 10000
#define DEF_NUMPROC   1          /* default number of processors */
#define DEF_NUMTHREAD 1          /* default number of threads */
#define DEF_SHMEMSIZE 1000000    /* default shared mem size */
#define DEF_STACKSIZE 100000     /* default stack size for threads */
#define DEF_TRACEFILE "awe.trc"  /* default trace file name */

/************************************************
 * AweThread thread class definition            *
 ************************************************/

class AweThread: public Thread{

 public:

  int      MyId;
  int      NumThreads;
  int      Argc;
  char     **Argv;

  int      NumberOfCollection;
  int      WarningCount;
  int      TraversalLevel;
  char     *CurrentCollectionTraversal[MAXPARAL];
  PTR_INFO TableOfCollection[MaxCollection];  

  double   TimerStart[64];
  double   TimerStop[64];
  double   TimerElapsed[64];

  AweThread(int, int, int, int, char **);
  virtual void main();

};

extern void Processor_Main();
extern void DuplicateGlobalVars(int num_threads);
